#include <stdio.h>
#include <string.h>
#include <math.h>
#include <conio.h>
#include <stdarg.h>
#include "asmlib.h"

TOperacao oplist8086[] = 
 { 
  {"JMP"    , {amRegister,  1, 1} , {amNone     , 0, 0} , {{1,1,1,1,1,1,1,1}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 0},
  {"JMP"    , {amDirect,    1, 1} , {amNone     , 0, 0} , {{1,1,1,1,1,1,1,1}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 0},
  {"MOV"    , {amRegister,  1, 1} , {amRegister , 1, 1} , {{1,0,0,0,1,0,0,0}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 1},
  {"MOV"    , {amRegister,  1, 1} , {amDirect   , 0, 0} , {{1,1,1,1,1,1,1,1}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 0},
  {"MOV"    , {amRegister,  1, 1} , {amImmediate, 1, 1} , {{0,0,0,0,1,1,0,1}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 7},
  {"LOOPNZ" , {amRegister,  1, 1} , {amDirect   , 0, 0} , {{1,1,1,1,1,1,1,1}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 0},
  {"ADD"    , {amRegister,  1, 1} , {amRegister , 1, 1} , {{0,0,0,0,0,0,0,0}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 2}, 1},
  {"ADD"    , {amRegister,  1, 1} , {amDirect   , 1, 1} , {{1,0,0,0,0,0,0,0}, {0,0,0,0,0,0,0,0}, 0, 0, 0, 4}, 2},
  {"NOT"    , {amRegister,  1, 1} , {amNone     , 1, 1} , {{0,1,1,0,1,1,1,1}, {0,0,0,0,1,0,0,0}, 0, 0, 0, 2}, 8}
  };

TOperacao GetOperation(char * Mnem, const TOperando * Op1m, const TOperando * Op2m){
 /*
   Percorre a tabela de operaes a procura de uma instruo que corresponda ao padro informado
 */
 int i;
 TOperacao Buffer;
 for (i = 0; i < oplist8086count; i++){
     if (!strcmp(oplist8086[i].Mnemonic, Mnem) &&
         (oplist8086[i].Op1.AddressMode==Op1m->AddressMode) &&
         (oplist8086[i].Op2.AddressMode==Op2m->AddressMode)){
        Buffer = oplist8086[i];
        if ((Op2m->Word || Op1m->Word) && (Buffer.Op2.AddressMode == amImmediate))
           Buffer.format.size += 1;
        return Buffer;
     };
 }
 printf("\nErr: Funo \"%s ", Mnem);
 ExibeTipoParametro(Op1m->AddressMode);
 printf(", ");
 ExibeTipoParametro(Op2m->AddressMode);
 printf(";\" no encontrada\n");
 exit(1);
};

int SplitInstruction(const char * Inst, char * Mnem, char * Op1, char * Op2){
 int i, j;
 int Step = 0;
 
 memset(Op1, 20, 0); 
 memset(Op2, 20, 0); 
 Op1[0]=0;
 Op2[0]=0;
 
 for (i = 0, j = 0; i < strlen(Inst); i++){  
     if ((Inst[i] == ';') && (Step == 2)) {
         /*Extrai o Primero operando

         j .. i
         */
         strncpy(Op2, Inst + (j + 1), i-(j+1));         
	     Op2[i-(j+1)] = 0;
	     
     }

     if (((Inst[i] == ',') || (Inst[i] == ';')) && (Step == 1)) {
         /*Extrai o Primero operando

         j .. i
         */
         
         Step = 2;
         strncpy(Op1, Inst + j, (i-j));
         Op1[(i-j)] = 0;         
         j = i + 1;         
     }

     if ((Inst[i] == ' ') && (Step == 0)) {
         /*Extrai o Mnemonico*/
         Step = 1;
         strncpy(Mnem, Inst, i);
         Mnem[i] = 0;
         j = i + 1;
     }

     if  (Inst[i] == ';') break;
 }
 return Step;
};
/*
{amNone, amRegister, amImmediate, amDirect, amRegIndirect,
                  amBaseIndex, amRegRelative, amBaseRelIndex};
*/
void GetAddressMode(char * Op, taddressmode *AM, int *Size){

	*Size = 0;
    *AM = amNone;

	if (strchr(Op, ':') != NULL) {
       *Size = 4;
       *AM = amDirectInterSeg;
       return;
    };

	switch (IsRegister(Op)) {
    	case 1: *Size = 1;
    	case 2: *Size = 2;
           *AM = amRegister;
           return;
		default: ;
    };

	switch (Op[0])
       case '[': {
			         switch (IsRegister(&Op[1])) {
			              case 1: *Size = 1;			                      
			              case 2: *Size = 2;
			                 if  (Op[3] == ']')
			                 {
			                     *AM = amRegIndirect; //mov ax, [bx]
			                 }
			                 else
			                 {
			                   //Verificar o que ha depois do sinal de soma
			    			   //AM = amBaseIndex; //mov ax, [si+bx]
			    			   //AM = amRegRelative; //mov ax, [bx+100]
			                 };
			                 return;
			              default: break;
                 break;
                 };         
       case '0':
       case '1':
       case '2':
       case '3':
       case '4':
       case '5':
       case '6':
       case '7':
       case '8':
       case '9': 
             printf("\nImediao\nOp[0]=%c",Op[0]);
             *AM = amImmediate;
             break;
    //AM = amDirect; //mov ax, [1000]
    };
};

int IsRegister(const char * txt) {
	int r = 0;

    if  (!(strcmp(txt, "AH") &&
           strcmp(txt, "BH") &&
           strcmp(txt, "CH") &&
           strcmp(txt, "DH") &&
           strcmp(txt, "AL") &&
           strcmp(txt, "BL") &&
           strcmp(txt, "CL") &&
           strcmp(txt, "DL"))){
           r = 1;
    };

    if  (!(strcmp(txt, "AX") &&
           strcmp(txt, "BX") &&
           strcmp(txt, "CX") &&
           strcmp(txt, "DX") &&
           strcmp(txt, "SP") &&
           strcmp(txt, "BP") &&
           strcmp(txt, "SI") &&
           strcmp(txt, "DI"))){
           r = 2;
    };
    debug("IsRegister(%s)", txt);
    debug("=%d\n", r);
    return r;
};

TOperando * EncodeOperando(char * Txt){
  int Size;
  TOperando * Buffer;
  Buffer = (TOperando*) calloc(sizeof(TOperando));
  debug("EncodeOperando(%s)\n", Txt);

  //Codifica o valor do operando
  Buffer->V.Byte = 0;
  Buffer->Word = FALSE;
  if  (strcmp(Txt, "")){  	  
  	  GetAddressMode(Txt, &Buffer->AddressMode, &Size);
  	  
  	  switch (Buffer->AddressMode){
  	  	case  amRegister:
  	  	case amImmediate: switch (IsRegister(Txt)) {  
						  	  case 0: Buffer->V.Byte = atoi(Txt);	  	  	  	         
						  	          break;
						  	          
						  	  case 1: Buffer->V.Reg = CodRegistrador(Txt);	  	          
						              break;
						              
						  	  case 2: Buffer->V.Reg = CodRegistrador(Txt);
						  	          Buffer->Word = TRUE;	  	          
						              break;
						  };
						  break;
		default: ;
	  };
  }
  else
  {
    Buffer->AddressMode = amNone;
  };
  return Buffer;
};

int CodRegistrador(const char * Reg){
  switch(Reg[0]) {
	case 'A': return (Reg[1] == 'H')? 4: 0;                  
	case 'C': return (Reg[1] == 'H')? 5: 1;
	case 'D': return (Reg[1] == 'H')? 6: (Reg[1]=='I')? 7: 2;
	case 'B': return (Reg[1] == 'H')? 7: (Reg[1]=='P')? 5: 3;
        case 'S': return (Reg[1] == 'P')? 4: 6;

  };
};

void EncodeModRM(Top8086rm * modrm, const TOperando *Op1, const TOperando *Op2){
  modrm->mod  = GetModRM(Op1->AddressMode, Op2->AddressMode);
  modrm->reg1 = Op1->V.Reg;
  modrm->reg2 = Op2->V.Reg;
};

void EncodeOperacao(TOperacao * Op){
	int buffer;
	switch (Op->tipo){
	  case 0: break;//somente o cdigo da table como push e pop
	  case 1:   //Opcode[dw] mod_rm
                EncodeModRM(&Op->format.data_modrm.mod_rm, &Op->Op1, &Op->Op2);
	 			Op->format.Opcode.dw.w = Op->Op2.Word | Op->Op1.Word;
	 			//Op->format.Opcode.dw.d = Op->Op2.Word | Op->Op1.Word;
				break;

      case 2:   //Opcode[dw] + data + [data]
                Op->format.Opcode.dw.w = Op->Op2.Word | Op->Op1.Word;
                Op->format.data_modrm.Byte = Op->Op2.V.Byte;
                if  (Op->Op1.Word) {
                    //codifica o segundo byte
                };
                break;
      case 3:   //Opcode[dw] + modrm + data + [data]
                Op->format.Opcode.dw.w = Op->Op2.Word | Op->Op1.Word;
                EncodeModRM(&Op->format.data_modrm.mod_rm, &Op->Op1, &Op->Op2);
                Op->format.data2 = Op->Op2.V.Byte;
                break;
      case 7:   //OpCode w Reg + data + [data]
                Op->format.Opcode.wreg.w = Op->Op2.Word | Op->Op1.Word;
                Op->format.Opcode.wreg.reg = Op->Op1.V.Reg;               
                buffer = Op->Op2.V.Word;
                Op->format.data_modrm.Byte = buffer;
                if  (Op->format.Opcode.wreg.w) {
                	Op->format.data_modrm.Byte = buffer;
                	Op->format.data2 = buffer >> 8;
                };
                break;
	  case 8:   //OpCode w + modrm 
	            // Somente 1 operando	  
                Op->format.Opcode.dw.w = Op->Op1.Word;
                Op->format.data_modrm.mod_rm.reg2 = Op->Op1.V.Reg;                               
                Op->format.data_modrm.mod_rm.mod = GetModRM(Op->Op1.AddressMode, amNone);                
                break;                
	}; 
};

void ExibeOperando(TOperando * cOp1){
	 printf("\n----- OPERANDO----- \n");
     printf("\n\tAddressMode: ");	 
	 ExibeTipoParametro(cOp1->AddressMode);
	printf("\n\tValue:\n");	 
	printf("\t\tReg: %d\n", cOp1->V.Reg);
    printf("\t\tWord: %d\n", cOp1->V.Word);
	printf("\t\tByte: %d\n", cOp1->V.Byte);     
    printf("\tWord: %d\n", cOp1->Word);
};

void ExibeOperacao(TOperacao * Operacao){
	printf("\n----- OPERACAO ----- \n");
	printf("\n\tMnemonic: %s", Operacao->Mnemonic);	
    printf("\n\tOpcode: ");
    ExibeFlat(&Operacao->format.Opcode.flat);
    printf("\n\tData_modrm: ");
    ExibeFlat(&Operacao->format.data_modrm.flat);    
	printf("\n\tData2: %d", Operacao->format.data2);
	printf("\n\tData3: %d", Operacao->format.data3);
	printf("\n\tData4: %d", Operacao->format.data4);
	printf("\n\tSize:  %d", Operacao->format.size);
};

void ExibeFlat(const TFlatByte* flat){
    printf("%d%d%d%d%d%d%d%d", flat->b7, flat->b6,
                               flat->b5, flat->b4,
                               flat->b3, flat->b2,
                               flat->b1, flat->b0);
};

void ExibeTipoParametro(const taddressmode am){
	switch(am){
	 	case amNone: printf("amNone");
	 	             break; 
	 	case amRegister: printf("amRegister");
	 	             break; 	 	
	 	case amImmediate: printf("amImmediate");
	 	             break; 	 	
	 	case amDirect: printf("amDirect");
	 	             break; 	 	
	 	case amRegIndirect: printf("amRegIndirect");
	 	             break; 	 	
	 	case amBaseIndex: printf("amBaseIndex");
	 	             break; 	 	
	 	case amRegRelative: printf("amRegRelative");
	 	             break; 	 	
	 	case amBaseRelIndex: printf("amBaseRelIndex");
	 	             break; 	 	
	 	case amDirectInterSeg: printf("amDirectInterSeg");
	 	             break; 	 	
	 	case amIndirectInterSeg: printf("amIndirectInterSeg");;
	 	             break; 	 	
	 };	
	 return;
};

void ListaOperacoes(void){
   int i = 0; 
   for (i = 0; i < oplist8086count; i++){
     ExibeOperacao(&oplist8086[i]);
   };
};

unsigned int GetModRM(const taddressmode am1, const taddressmode am2){
  switch(am1){
    case amRegister:     return 3;
    case amImmediate:    return 99;
    case amDirect:       return 99;
    case amRegIndirect:  return 0;
    case amBaseIndex:    return 99;
    case amRegRelative:  return 99;
    case amBaseRelIndex: return 99;
    case amDirectInterSeg: return 99;
    case amIndirectInterSeg: return 99;
  };
};

